# 社区开发者测试贡献指南

openEuler社区作为一个开发，创新的平台，欢迎业界所有开发者参与贡献，社区质量保障体系同样需要开发者共同构筑。

在进行贡献前，请先签署[CLA](https://openeuler.org/en/cla.html)

开发者可以从单包级、版本级、工具级三个维度进行openEuler社区测试保障的贡献，详细介绍如下：

## 单包级贡献

### 介绍

单包的质量保障包括如下两方面：

- 开发者测试  
- 社区众测  

#### 开发者测试

开发者贡献测试代码到软件包对应的上游社区中，通过spec文件中指定的make check动作，在OBS构建二进制包的时候会进行相应用例的测试执行。开发者也可以直接贡献代码到openEuler社区对应项目中。

- 上游社区有相应测试代码时，开发者按照上游社区的贡献规则进行  
- 上游社区没有相应测试代码时，开发者和上游社区maintainer讨论贡献规则并进行贡献  

#### 社区众测

##### 开发者参与openEuler社区即将发布新需求/特性的测试活动

- 需求分析  

  需求清单可结合[release-management](https://gitee.com/openeuler/release-management)团队的版本发布计划和[社区需求跟踪单](https://gitee.com/open_euler/dashboard/issues?issue_type_id=118737&search=20.09)来查找，详细实现细节可通过需求单评论区链接或者关联仓库查看。

- 测试方案设计  

  在了解清楚特性实现细节后，参考[测试设计方案模板]((https://gitee.com/openeuler/package-reinforce-test/blob/master/单软件包加固测试设计方案参考.mmap))进行测试设计，可通过提PR的方式到[QA](https://gitee.com/openeuler/QA)与QA团队进行方案的讨论

- 编写测试代码  

  openEuler社区已开放[mugen](https://gitee.com/openeuler/test-tools/tree/master/mugen)测试框架，开发者根据讨论后的测试方案按照[测试用例命名及代码编程规范](https://gitee.com/openeuler/package-reinforce-test/blob/master/测试用例命名及代码编程规范.md)编写代码和本地调试

- 代码提交  

  完成编码和调试后，开发者通过PR提交代码到[代码仓](https://gitee.com/openeuler/package-reinforce-test)

##### 开发者参与openEuler社区发布软件包的加固测试

此部分请参考[包加固测试](https://gitee.com/openeuler/package-reinforce-test)

### 说明：

- 虚拟化组件相关组件包测试代码贡献敬请期待  
- 容器组件相关组件包测试代码贡献敬请期待  

## 版本级测试贡献

openEuler社区版本发布计划请移步[releasemanagement](https://gitee.com/openeuler/release-management)，开发者根据[社区测试体系介绍](https://gitee.com/openeuler/QA)中版本级的测试活动进行相应贡献，具体贡献仓库参见[QA](https://gitee.com/openeuler/QA)中repo地址列表和[repo仓库描述](https://gitee.com/openeuler/community/blob/master/repository/openeuler.yaml)

## 工具贡献

openEuler社区生态的构建和质量保障离不开高效快捷的工具，对QA团队也不例外。开发者可以贡献各类工具到[工具仓](https://gitee.com/openeuler/test-tools)，包括不限于：

- 集成先进测试理念和能力的工具  
- 高效率的测试框架  
- 提高编码效率的工具

